#define ON 1
#define OFF 0
 
 
/*
 * Set frequency of oscillator feeding speaker.
 */
 
setfreq(hertz) {
         unsigned divisor = 1193180L/hertz ;
         outportb(0x43, 0xB6) ;
         outportb(0x42, divisor & 0377) ;
         outportb(0x42, divisor >> 8) ;
}
 
 
/*
 * Turn speaker on or off.
 */
 
speaker(on) {
         int portval ;
 
         portval = inportb(0x61) ;
         if (on)   portval |= 03 ;
         else      portval &=~ 03 ;
         outportb(0x61, portval) ;
}
